<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>DataSourceFromResult</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/voting-material/register/register-upload/register-upload.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(data: <a href="../classes/RegisterUploadResult.html">RegisterUploadResult</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="115" class="link-to-prism">src/app/operation/voting-material/register/register-upload/register-upload.component.ts:115</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>data</td>
                                                  
                                                        <td>
                                                                    <code><a href="../classes/RegisterUploadResult.html" target="_self" >RegisterUploadResult</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="121" class="link-to-prism">src/app/operation/voting-material/register/register-upload/register-upload.component.ts:121</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;any[]&gt;</code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="125" class="link-to-prism">src/app/operation/voting-material/register/register-upload/register-upload.component.ts:125</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, Input, ViewChild } from &#x27;@angular/core&#x27;;
import { MatSnackBar } from &#x27;@angular/material&#x27;;
import { TranslateService } from &#x27;@ngx-translate/core&#x27;;
import { FileService } from &#x27;../../../../core/service/file-service/file-service&#x27;;
import { DataSource } from &#x27;@angular/cdk/collections&#x27;;
import { Observable } from &#x27;rxjs/Observable&#x27;;
import { ActivatedRoute, Router } from &#x27;@angular/router&#x27;;
import { Operation } from &#x27;../../../model/operation&#x27;;
import { RegisterUploadResult } from &#x27;../model/register-upload-result&#x27;;
import { RegisterService } from &#x27;../services/register.service&#x27;;
import { OperationManagementService } from &#x27;../../../service/operation-managment.service&#x27;;
import { of } from &#x27;rxjs/observable/of&#x27;;
import { ConfirmBeforeQuit } from &#x27;../../../../core/confirm-before-quit&#x27;;
import { UploadInputComponent } from &#x27;../../../../shared/upload-input/upload-input.component&#x27;;


@Component({
  selector: &#x27;register-upload&#x27;,
  templateUrl: &#x27;./register-upload.component.html&#x27;,
  styleUrls: [&#x27;./register-upload.component.scss&#x27;]
})
export class RegisterUploadComponent implements ConfirmBeforeQuit {
  result: RegisterUploadResult;

  dataSource: DataSourceFromResult;
  displayedColumns &#x3D; [&quot;fileName&quot;, &quot;emitter&quot;, &quot;emissionDate&quot;, &quot;voterCount&quot;, &quot;doiCount&quot;, &quot;countingCircleCount&quot;,
    &quot;detailedReport&quot;];
  @Input()
  operation: Operation;
  @ViewChild(UploadInputComponent)
  uploadInput: UploadInputComponent;
  private validated &#x3D; false;

  constructor(private route: ActivatedRoute,
              private registerService: RegisterService,
              private snackBar: MatSnackBar,
              private translateService: TranslateService,
              private operationManagementService: OperationManagementService,
              private router: Router,
              private fileService: FileService) {
  }

  get uploadUrl(): string {
    return &#x60;${this.registerService.serviceUrl}/${this.operation.id}/upload&#x60;;
  }

  isFormModified(): boolean {
    return this.uploadInput.isFormModified() || this.isValid() &amp;&amp; !this.validated;
  }

  resetResult() {
    this.result &#x3D; undefined;
  }

  setResult(result: RegisterUploadResult) {
    this.result &#x3D; result;
    this.dataSource &#x3D; new DataSourceFromResult(this.result);
  }

  downloadDuplicates() {
    this.download(&quot;duplicate.csv&quot;,
      this.fileService.generateCsvFromFlatObject(this.result.duplicates,
        &quot;voting-material.register.upload.errors.duplicate.csv.header&quot;));
  }

  downloadUndefinedDois() {
    this.download(&quot;voters-without-doi.csv&quot;,
      this.fileService.generateCsvFromFlatObject(this.result.undefinedDois,
        &quot;voting-material.register.upload.errors.undefined-doi.csv.header&quot;));
  }

  downloadValidationReport() {
    this.download(&quot;validationError.csv&quot;,
      this.fileService.generateCsvFromFlatObject(this.result.validationErrors,
        &quot;voting-material.register.upload.errors.schema-validation.csv.header&quot;));
  }

  getReport() {
    this.fileService.downloadFile(&quot;report.pdf&quot;, this.result.detailedReport, true);
  }


  download(fileName: string, content: string) {
    this.fileService.downloadFile(fileName, content);
  }

  isValid() {
    return this.result &amp;&amp;
           this.result.validationErrors.length &#x3D;&#x3D; 0 &amp;&amp;
           this.result.duplicates.length &#x3D;&#x3D; 0 &amp;&amp;
           this.result.undefinedDois.length &#x3D;&#x3D; 0;
  }

  importRegister() {
    this.registerService.validateUpload(this.result.messageUniqueId, this.operation.id)
      .subscribe(() &#x3D;&gt; {
          this.snackBar.open(
            this.translateService.instant(&#x27;voting-material.register.upload.upload-succeed&#x27;), &#x27;&#x27;, {
              duration: 5000
            });
          this.operationManagementService.shouldUpdateStatus();
          this.validated &#x3D; true
          this.router.navigate([&quot;..&quot;], {relativeTo: this.route});
        }
      );

  }

  cancelImport() {
    this.router.navigate([&quot;..&quot;], {relativeTo: this.route});
  }
}


class DataSourceFromResult extends DataSource&lt;any&gt; {

  constructor(private data: RegisterUploadResult) {
    super();
  }

  connect(): Observable&lt;any[]&gt; {
    return of([this.data]);
  }

  disconnect() {
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'DataSourceFromResult.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
